Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Alignement.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Alignement.java	(revision 785)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Alignement.java	(revision 786)
@@ -7,7 +7,7 @@
 import org.txm.Toolbox;
 import org.txm.objects.Edition;
 import org.txm.objects.Page;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
 import org.txm.searchengine.cqp.corpus.query.Match;
@@ -64,8 +64,8 @@
 		{
 			QueryResult rez = src.query(new Query("[_.text_id=\""+textid+"\" & id=\""+wordid+"\"]"), "Align", false);
 			int[] position = {rez.getMatch(0).getStart()};
-			int[] struct_align_pos = CQPEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
-			String[] struct_align_str = CQPEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
+			int[] struct_align_pos = CQPSearchEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
+			String[] struct_align_str = CQPSearchEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
 			if(struct_align_str.length > 0)
 			{
 				String aligned_struct = struct_align_str[0]; // the struct align value
@@ -73,8 +73,8 @@
 				QueryResult rez2 = dest.query(new Query("<"+struct+"_align=\""+aligned_struct+"\">[]"), "Align", false);
 				int[] position2 = {rez2.getMatch(0).getStart()};
 				// get the id of this position
-				int[] struct_text_pos = CQPEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position2);
-				String[] struct_text_str = CQPEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
+				int[] struct_text_pos = CQPSearchEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position2);
+				String[] struct_text_str = CQPSearchEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
 				return Arrays.asList(wordid, struct_text_str[0]);
 			}
 			else
@@ -91,8 +91,8 @@
 			//System.out.println(rez.getMatches());
 			int[] position = {rez.getMatch(0).getStart()};
 			//get the struct@align value for this position
-			int[] struct_align_pos = CQPEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
-			String[] struct_align_str = CQPEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
+			int[] struct_align_pos = CQPSearchEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
+			String[] struct_align_str = CQPSearchEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
 			if(struct_align_str.length > 0)
 			{
 				String aligned_struct = struct_align_str[0]; // the struct align value
@@ -101,12 +101,12 @@
 				QueryResult rez2 = dest.query(new Query(query), "Align", false);
 				int[] position2 = {rez2.getMatch(0).getStart()};
 				// get the id of this position
-				String[] ids = CQPEngine.getCqiClient().cpos2Str(id_dest.getQualifiedName(), position2);
+				String[] ids = CQPSearchEngine.getCqiClient().cpos2Str(id_dest.getQualifiedName(), position2);
 
 				if(ids.length > 0)
 				{
-					int[] struct_text_pos = CQPEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position2);
-					String[] struct_text_str = CQPEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
+					int[] struct_text_pos = CQPSearchEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position2);
+					String[] struct_text_str = CQPSearchEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
 					return Arrays.asList(ids[0], struct_text_str[0]);
 				}
 				else
@@ -146,8 +146,8 @@
 		Corpus src = CorpusManager.getCorpusManager().getCorpus(from);
 		StructuralUnitProperty align_src = src.getStructuralUnit(struct).getProperty("align");
 		int[] position = {idx};
-		int[] struct_align_pos = CQPEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
-		String[] struct_align_str = CQPEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
+		int[] struct_align_pos = CQPSearchEngine.getCqiClient().cpos2Struc(align_src.getQualifiedName(), position);
+		String[] struct_align_str = CQPSearchEngine.getCqiClient().struc2Str(align_src.getQualifiedName(), struct_align_pos);
 		if (struct_align_str.length > 0) {
 			return resolveSeg(struct_align_str[0]);
 		}
@@ -166,12 +166,12 @@
 		int[] position = {rez.getMatch(0).getStart()};
 
 		Property id_dest = dest.getProperty("id");
-		String[] ids = CQPEngine.getCqiClient().cpos2Str(id_dest.getQualifiedName(), position);
+		String[] ids = CQPSearchEngine.getCqiClient().cpos2Str(id_dest.getQualifiedName(), position);
 		String wordid = ids[0];
 
 		StructuralUnitProperty text_dest = dest.getStructuralUnit("text").getProperty("id");
-		int[] struct_text_pos = CQPEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position);
-		String[] struct_text_str = CQPEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
+		int[] struct_text_pos = CQPSearchEngine.getCqiClient().cpos2Struc(text_dest.getQualifiedName(), position);
+		String[] struct_text_str = CQPSearchEngine.getCqiClient().struc2Str(text_dest.getQualifiedName(), struct_text_pos);
 		String textid = struct_text_str[0];
 		
 		return Arrays.asList(wordid, textid);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java	(revision 785)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/CorpusManager.java	(revision 786)
@@ -33,7 +33,7 @@
 import org.txm.Toolbox;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.searchengine.cqp.AbstractCqiClient;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.NetCqiClient;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.clientExceptions.InvalidCqpIdException;
@@ -215,9 +215,9 @@
 	public static void deleteCorpus(MainCorpus corpus) {
 		if (corpora != null)
 			corpora.remove(corpus);
-		if (CQPEngine.isInitialized()) {
+		if (CQPSearchEngine.isInitialized()) {
 			try {
-				CQPEngine.getCqiClient().dropCorpus(corpus.getName());
+				CQPSearchEngine.getCqiClient().dropCorpus(corpus.getName());
 			} catch (Exception e) {
 				Log.warning("Warning while removing corpus: Failed to drop corpus "+corpus);
 				Log.printStackTrace(e);
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java	(revision 0)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/CQPSearchEngine.java	(revision 786)
@@ -0,0 +1,403 @@
+package org.txm.searchengine.cqp;
+
+import java.io.File;
+import java.io.IOException;
+import java.lang.reflect.Constructor;
+import java.util.ArrayList;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.Platform;
+import org.osgi.framework.Bundle;
+import org.txm.Toolbox;
+import org.txm.core.engines.EngineType;
+import org.txm.core.messages.TXMCoreMessages;
+import org.txm.core.preferences.TBXPreferences;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.importer.cwb.PatchCwbRegistry;
+import org.txm.libs.cqp.CQPLibPreferences;
+import org.txm.objects.Base;
+import org.txm.searchengine.core.SearchEngine;
+import org.txm.searchengine.cqp.clientExceptions.ServerNotFoundException;
+import org.txm.searchengine.cqp.corpus.CorpusManager;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.utils.OSDetector;
+import org.txm.utils.Sh;
+import org.txm.utils.logger.Log;
+import org.w3c.dom.Element;
+
+public class CQPSearchEngine extends SearchEngine {
+
+	/**
+	 * initialization state
+	 */
+	boolean state = false;
+	boolean useNetCQi = false;
+
+	@Override
+	public String getName() {
+		return "CQP";
+	}
+
+	/**
+	 * Starts the corpus engine if not remove then launch cqpserver.
+	 *
+	 * @return true, if successful
+	 */
+	public boolean start(IProgressMonitor monitor) throws Exception {
+
+		if (monitor != null) monitor.subTask("Starting Corpus Engine...");
+
+		boolean cqiserverok = false;
+
+		useNetCQi = Boolean.parseBoolean(TXMPreferences.getString(CQPLibPreferences.CQI_NETWORK_MODE, CQPLibPreferences.PREFERENCES_NODE));
+
+		Log.warning("Killing CQP and RServe process if any");
+		killSearchEngine();
+
+
+		boolean remote = Boolean.parseBoolean(TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_IS_REMOTE, CQPLibPreferences.PREFERENCES_NODE));
+		state = false;
+		// test if must-have properties for CWB are set
+
+
+		String reg_path = ""; // new way that concats registry of loaded corpus
+		String path_separator = System.getProperty("path.separator");
+		for (Base b : Toolbox.workspace.getProject("default").getBases()) {
+			File binDir = b.getBaseDirectory();
+			File registryDir = new File(binDir, "registry");
+			reg_path += path_separator + registryDir.getAbsolutePath();
+			File[] files = registryDir.listFiles();
+			if (files != null)
+				for (File registryFile : files) {
+					if (registryFile.isHidden()) continue;
+					if (registryFile.isDirectory()) continue;
+
+					File dataDirectory = new File(binDir, "data/"+registryFile.getName().toUpperCase());
+					if (!dataDirectory.exists())dataDirectory = new File(binDir, "data"); // eventual old corpus
+					try {
+						PatchCwbRegistry.patch(registryFile, dataDirectory);
+					} catch (IOException e) {
+						System.out.println("Error while updating registry file "+registryFile+": "+e);
+						Log.printStackTrace(e);
+						return false;
+					}
+				}
+		}
+		if (reg_path.length() > 0) reg_path = reg_path.substring(path_separator.length()); // remove first path_separator
+		reg_path = reg_path.replace("\\\\", "//"); // fix the UNC paths for mingw
+
+		String init_path = TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PATH_TO_INIT_FILE, CQPLibPreferences.PREFERENCES_NODE);
+
+
+		if (!remote) {
+
+			if (!useNetCQi) {
+				try {
+					cqiServer = new MemCqiServer(reg_path, 
+							init_path, 
+							TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_ADDITIONAL_OPTIONS, CQPLibPreferences.PREFERENCES_NODE)
+							+ " -P " + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE), //$NON-NLS-1$
+							Boolean.parseBoolean(TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_MONITOR_OUTPUT, CQPLibPreferences.PREFERENCES_NODE)));
+				} catch (Exception e) {
+					// TODO Auto-generated catch block
+					org.txm.utils.logger.Log.printStackTrace(e);
+				}
+			} else {
+
+				String exec_path = TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PATH_TO_EXECUTABLE, CQPLibPreferences.PREFERENCES_NODE);
+
+				if (exec_path == null || exec_path.length() == 0) {
+					System.out.println("Error: the '"+CQPLibPreferences.CQI_SERVER_PATH_TO_EXECUTABLE+"' preference is not set.");
+				}
+				if (new File(exec_path).exists()) {
+					System.out.println("Error: the '"+CQPLibPreferences.CQI_SERVER_PATH_TO_EXECUTABLE+"' preference is not set.");
+				}
+
+				cqiServer = new NetCqiServer(exec_path,
+						reg_path, 
+						init_path, 
+						TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_ADDITIONAL_OPTIONS, CQPLibPreferences.PREFERENCES_NODE)
+						+ " -P " + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE), //$NON-NLS-1$
+						Boolean.parseBoolean(TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_MONITOR_OUTPUT, CQPLibPreferences.PREFERENCES_NODE)));
+			}
+
+			if (cqiServer != null)
+				cqiserverok = cqiServer.start();
+
+		}
+
+		// create cqi client
+		try {
+			if (cqiserverok) {
+				if (!useNetCQi) {
+					try {
+						cqiClient = new MemCqiClient((MemCqiServer) cqiServer);
+					} catch(Exception e) {
+						Log.severe(TXMCoreMessages.Toolbox_28+e);
+						cqiserverok = false;
+					}
+				} else {
+					int port = Integer.parseInt(TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE));
+					String host = TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_HOST, CQPLibPreferences.PREFERENCES_NODE);
+					cqiClient = new NetCqiClient(host, port);
+				}
+			}
+		} catch (NumberFormatException e1) {
+			Log.severe(TXMCoreMessages.Toolbox_wrong_port + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE)); 
+		} catch (ServerNotFoundException e1) {
+			Log.severe(TXMCoreMessages.Error_CONNECTION_FAILED + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_HOST, CQPLibPreferences.PREFERENCES_NODE)
+					+ TXMCoreMessages.Toolbox_27 + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE)); 
+		}
+
+		// try connecting to the CWB server
+		try {
+			if (cqiserverok) {
+				String login = TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_LOGIN, CQPLibPreferences.PREFERENCES_NODE);
+				String password = TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PASSWORD, CQPLibPreferences.PREFERENCES_NODE);
+				state = cqiClient.connect(login, password);
+			}
+		} catch (Exception e1) {
+			Log.severe(Log.toString(e1));
+		}
+
+		if (state == false) {
+			System.out.println(TXMCoreMessages.Toolbox_29); 
+			if (cqiClient instanceof NetCqiClient) System.out.println(TXMCoreMessages.Toolbox_30 + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_LOGIN, CQPLibPreferences.PREFERENCES_NODE) + " " + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PASSWORD, CQPLibPreferences.PREFERENCES_NODE) + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_HOST, CQPLibPreferences.PREFERENCES_NODE) + " " + Integer.parseInt(TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE))); //$NON-NLS-1$ //$NON-NLS-2$
+			if (cqiServer != null && cqiServer instanceof NetCqiServer)
+				System.out.println(TXMCoreMessages.Toolbox_33 + cqiServer.getLastCmdLine());
+		} else {
+			if (cqiServer == null || cqiServer instanceof NetCqiServer)
+				System.out.println(TXMCoreMessages.Toolbox_connected_to_corpus_sever); 
+		}
+
+		CorpusManager.setCqiClient(cqiClient);
+
+		// wait for CQPSERVER TO BE READY
+		int scount = 0;
+		try {
+			CorpusManager.getCorpusManager().getCorpora();
+			do {
+				Thread.sleep(100);
+				CorpusManager.cleanCorpora();// to be sure to call cqpserver
+				CorpusManager.getCorpusManager().getCorpora();
+				scount++;
+				if (scount >= 10) {
+					Log.warning(TXMCoreMessages.Toolbox_17); 
+					break;
+				}
+			} while (CorpusManager.getCorpusManager().getCorpora().size() == 0);
+		} catch (Exception e) {
+			org.txm.utils.logger.Log.printStackTrace(e);
+			Log.severe(TXMCoreMessages.Toolbox_18 + e);
+		} 
+
+		if (Toolbox.workspace == null) {
+			System.out.println("Can't start CQP with workspace not ready.");
+			return false;
+		}
+
+		// initialize pre-configured subcorpus and partition of corpus registered in the default.xml workspace file
+		System.out.print(TXMCoreMessages.Toolbox_workspace_init);
+		for (Base b : Toolbox.workspace.getProject("default").getBases()) {
+			if (!loadCQPCorpora(b, monitor)) {
+				System.out.println("Failed to load CQP corpora of "+b.getName()+" corpus.");
+			}
+		}
+		
+		System.out.println(TXMCoreMessages.common_done);
+
+		return state;
+	}
+
+	public boolean loadCQPCorpora(Base base, IProgressMonitor monitor) {
+		//System.out.println("Load corpus from params: "+params.corpora);
+		for (String corpusname : base.getBaseParameters().corpora.keySet()) {
+			Element c = base.getBaseParameters().corpora.get(corpusname);
+			try {
+				MainCorpus corp = CorpusManager.getCorpusManager().getCorpus(corpusname);
+				if (monitor != null) monitor.subTask("Loading "+corp+" subcorpora and partitions...");
+				corp.setSelfElement(c);
+				corp.setParent(base);
+				corp.load(); // don't load corpus right now, wait for the search engine to be ready
+				base.addChild(corp);
+				if (!corp.getMetadatas().containsKey("lang")) { //$NON-NLS-1$
+					corp.setAttribute("lang", c.getAttribute("lang")); //$NON-NLS-1$ //$NON-NLS-2$
+				}
+			} catch (Exception e) {
+				System.out.println(e.getLocalizedMessage());
+				org.txm.utils.logger.Log.printStackTrace(e);
+				return false;
+			}
+		}
+		return true;
+	}
+
+	@Override
+	public boolean initialize() {
+		// all initialization done in the start method because we need CQP executable/lib to restart from the beginning
+		return true;
+	}
+
+	/** The CQI server. */
+	private static AbstractCqiServer cqiServer;
+
+	/** The CQI client. */
+	private static AbstractCqiClient cqiClient;
+
+	/**
+	 * Sets the CQI server.
+	 *
+	 * @param cqiServer the new cqi server
+	 */
+	public static void setCqiServer(AbstractCqiServer cqiServer) {
+		CQPSearchEngine.cqiServer = cqiServer;
+	}
+
+	/**
+	 * Gets the cqi client.
+	 *
+	 * @return the cqi client
+	 */
+	public static AbstractCqiClient getCqiClient() {
+		return cqiClient;
+	}
+
+	/**
+	 * Sets the cqi client.
+	 *
+	 * @param cqiClient the new cqi client
+	 */
+	public static void setCqiClient(NetCqiClient cqiClient) {
+		CQPSearchEngine.cqiClient = cqiClient;
+	}
+
+	/**
+	 * Gets the CQI server.
+	 *
+	 * @return the CQI server
+	 */
+	public static AbstractCqiServer getCqiServer() {
+		return cqiServer;
+	}
+
+	/**
+	 * Shut the toolbox searchengine down.
+	 */
+	public boolean stop() {
+		try {
+			if (cqiClient instanceof MemCqiClient) {
+				try  {
+				} catch(Exception e) {}
+				for (String name : ((MemCqiClient)cqiClient).listCorpora()) {
+					((MemCqiClient)cqiClient).dropCorpus(name);
+				}
+			}
+			cqiClient.disconnect();
+			cqiServer.stop();
+
+			CorpusManager.clean();
+			if (cqiServer instanceof NetCqiServer)
+				killSearchEngine();
+
+			state = false;
+		} catch (Exception e) {
+			Log.severe("Error while closing CQP: "+e.getLocalizedMessage());
+			return false;
+		}
+		return true;
+	}
+
+	/**
+	 * kill cqpserver process.
+	 */
+	private static void killSearchEngine() {
+		if (!TXMPreferences.getBoolean(CQPLibPreferences.CQI_SERVER_IS_REMOTE, CQPLibPreferences.PREFERENCES_NODE))
+			// Windows OS
+			if (OSDetector.isFamilyWindows()) {
+				try {
+					Process p = Runtime.getRuntime().exec(
+							"taskkill /IM cqpserver.exe /F"); //$NON-NLS-1$
+					p.waitFor();
+					p = Runtime.getRuntime().exec("taskkill /IM cqpserver.exe /F"); //$NON-NLS-1$
+					p.waitFor();
+				} catch (IOException e) {
+					Log.severe(TXMCoreMessages.Toolbox_31+Log.toString(e));
+					System.out.println(TXMCoreMessages.Toolbox_31+Log.toString(e));
+					try {
+						Process p = Runtime.getRuntime().exec(
+								"tskill cqpserver.exe"); //$NON-NLS-1$
+						p.waitFor();
+						p = Runtime.getRuntime().exec("tskill cqpserver.exe"); //$NON-NLS-1$
+						p.waitFor();
+					} catch (IOException e2) {
+						Log.severe(TXMCoreMessages.Toolbox_34+Log.toString(e2));
+						System.out.println(TXMCoreMessages.Toolbox_34+Log.toString(e2));
+					} catch (InterruptedException e3) {
+						Log.severe(Log.toString(e3));
+						System.out.println(Log.toString(e3));
+					}
+				} catch (InterruptedException e) {
+					Log.severe("Error while closing CQP: "+e.getLocalizedMessage());
+					System.out.println(Log.toString(e));
+				}
+				;
+			}
+		// Mac, Linux
+			else {
+				String cmd = TXMCoreMessages.Toolbox_37 + TXMPreferences.getString(CQPLibPreferences.CQI_SERVER_PORT, CQPLibPreferences.PREFERENCES_NODE) + TXMCoreMessages.Toolbox_38;
+				try {
+					//Process p = Runtime.getRuntime().exec("killall -9 cqpserver"); //$NON-NLS-1$
+					// System.out.println("kill `ps aux | grep cqpserver | awk '/-P "
+					// + TXMPreferences.getString(CQPPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
+					// String[] args =
+					// {"kill","`ps aux | grep cqpserver | awk '/-P " +
+					// TXMPreferences.getString(CQPPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`"};
+					// System.out.println("before Sh constructor");
+					Sh sh = new Sh(""); //$NON-NLS-1$
+					// System.out.println("after Sh constructor");
+					// System.out.println("EXECUTE SH : "+"kill `ps aux | grep cqpserver | awk '/-P "
+					// + TXMPreferences.getString(CQPPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
+					sh.setIsc(cmd);
+					sh.sh();
+					// Runtime.getRuntime().exec("sh kill `ps aux | grep cqpserver | awk '/-P "
+					// + TXMPreferences.getString(CQPPreferences.PREFERENCES_NODE, CQI_SERVER_PORT) + "/ {print $2}'`");
+
+				} catch (Exception e) {
+					Log.severe(TXMCoreMessages.Toolbox_39+cmd+TXMCoreMessages.Toolbox_40+Log.toString(e));
+					System.out.println(TXMCoreMessages.Toolbox_39+cmd+TXMCoreMessages.Toolbox_40+Log.toString(e));
+					org.txm.utils.logger.Log.printStackTrace(e);
+				}
+			}
+	}
+
+	/**
+	 * Restart the toolbox's searchengine.
+	 *
+	 * @return true, if successful
+	 */
+	public boolean restart() {
+		try {
+			boolean ret = stop();
+			Thread.sleep(10);
+			ret = ret && start(null);
+			return ret;
+		} catch (Exception e) {
+			Log.severe("Error while restarting CQP: "+e.getLocalizedMessage());
+		}
+		return false;
+	}
+
+	/**
+	 * test if searchEngine is initialized.
+	 *
+	 * @return true, if is initialized
+	 */
+	public static boolean isInitialized() {
+		return Toolbox.getEngineManager(EngineType.SEARCH).getEngine("CQP").getState();
+	}
+
+	@Override
+	public boolean getState() {
+		return state;
+	}
+}

Index: tmp/org.txm.para.core/src/org/txm/para/core/functions/ParallelContexts.java
===================================================================
--- tmp/org.txm.para.core/src/org/txm/para/core/functions/ParallelContexts.java	(revision 785)
+++ tmp/org.txm.para.core/src/org/txm/para/core/functions/ParallelContexts.java	(revision 786)
@@ -11,7 +11,7 @@
 
 import org.txm.Toolbox;
 import org.txm.searchengine.cqp.AbstractCqiClient;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.CorpusManager;
@@ -69,8 +69,8 @@
 
 				StructuralUnitProperty align_id = corpus.getStructuralUnit(struct).getProperty(structprop);
 				System.out.println("struct: "+struct+" prop: "+structprop+" -> "+align_id);
-				int[] struct_pos = CQPEngine.getCqiClient().cpos2Struc(align_id.getQualifiedName(), positions);
-				String[] struct_ids = CQPEngine.getCqiClient().struc2Str(align_id.getQualifiedName(), struct_pos);
+				int[] struct_pos = CQPSearchEngine.getCqiClient().cpos2Struc(align_id.getQualifiedName(), positions);
+				String[] struct_ids = CQPSearchEngine.getCqiClient().struc2Str(align_id.getQualifiedName(), struct_pos);
 
 				// fill allsegments
 				for (int i = 0 ; i < struct_ids.length ; i++) {
@@ -165,16 +165,16 @@
 				// get the seg that actually are in the corpus
 				QueryResult resul2t = corpus.query(new Query(segquery), "TMP", true);
 				int[] struct_starts = resul2t.getStarts();
-				int[] struct_pos = CQPEngine.getCqiClient().cpos2Struc(align_id.getQualifiedName(), struct_starts);
-				String[] struct_ids = CQPEngine.getCqiClient().struc2Str(align_id.getQualifiedName(), struct_pos);
+				int[] struct_pos = CQPSearchEngine.getCqiClient().cpos2Struc(align_id.getQualifiedName(), struct_starts);
+				String[] struct_ids = CQPSearchEngine.getCqiClient().struc2Str(align_id.getQualifiedName(), struct_pos);
 
 				//System.out.println("segs: "+Arrays.toString(struct_ids));
 
 				// get ref if asked
 				String[] ref_values = null;
 				if (ref != null) {
-					int[] struct_pos2 = CQPEngine.getCqiClient().cpos2Struc(ref.getQualifiedName(), struct_starts);
-					ref_values = CQPEngine.getCqiClient().struc2Str(ref.getQualifiedName(), struct_pos2);
+					int[] struct_pos2 = CQPSearchEngine.getCqiClient().cpos2Struc(ref.getQualifiedName(), struct_starts);
+					ref_values = CQPSearchEngine.getCqiClient().struc2Str(ref.getQualifiedName(), struct_pos2);
 				}
 				//System.out.println("ref values: "+Arrays.toString(ref_values));
 
Index: tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEnginesManager.java
===================================================================
--- tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEnginesManager.java	(revision 785)
+++ tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEnginesManager.java	(revision 786)
@@ -11,6 +11,7 @@
  * @author sjacquot
  *
  */
+//FIXME: useless class, the type and priority/order should be defined in org.txm.core.engines.EnginesManager extension point
 public class StatsEnginesManager extends EnginesManager<StatsEngine> {
 
 	public static StatsEngine getREngine() {
Index: tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEngine.java
===================================================================
--- tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEngine.java	(revision 785)
+++ tmp/org.txm.statsengine.core/src/org/txm/statsengine/core/StatsEngine.java	(revision 786)
@@ -2,6 +2,7 @@
 
 import org.txm.core.engines.Engine;
 
+//FIXME: useless class
 public abstract class StatsEngine implements Engine {
 
 	public static final String EXTENSION_POINT_ID = "org.txm.statsengine.core.StatsEngine"; //$NON-NLS-1$
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/CreateCQPListMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/CreateCQPListMacro.groovy	(revision 785)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/CreateCQPListMacro.groovy	(revision 786)
@@ -40,7 +40,7 @@
 import org.txm.Toolbox
 import org.txm.searchengine.cqp.*
 
-def CQI = CQPEngine.getCqiClient();
+def CQI = CQPSearchEngine.getCqiClient();
 if ((CQI instanceof NetCqiClient)) {
 	println "Error: only available in CQP memory mode"
 	return;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/ExecCQPMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/ExecCQPMacro.groovy	(revision 785)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/ExecCQPMacro.groovy	(revision 786)
@@ -50,7 +50,7 @@
 import org.txm.searchengine.cqp.*
 
 // Sanity check - Vérification de cohérence
-def CQI = CQPEngine.getCqiClient();
+def CQI = CQPSearchEngine.getCqiClient();
 if ((CQI instanceof NetCqiClient)) {
 	println "Error: CQP eval only available in CQP memory mode"
 	return;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/SetMatchingStrategyMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/SetMatchingStrategyMacro.groovy	(revision 785)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/cqp/SetMatchingStrategyMacro.groovy	(revision 786)
@@ -11,7 +11,7 @@
 if (current != null)
 	println "Current strategy is: $current"
 
-def CQI = CQPEngine.getCqiClient();
+def CQI = CQPSearchEngine.getCqiClient();
 if ((CQI instanceof NetCqiClient)) {
 	println "Error: only available in CQP memory mode"
 	return;
Index: tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java
===================================================================
--- tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java	(revision 785)
+++ tmp/org.txm.internalview.rcp/src/org/txm/internalview/rcp/editors/InternalViewEditor.java	(revision 786)
@@ -35,7 +35,7 @@
 import org.txm.rcp.swt.widget.NewNavigationWidget;
 import org.txm.rcp.swt.widget.PropertiesSelector;
 import org.txm.rcp.swt.widget.structures.StructuralUnitsComboViewer;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
@@ -364,7 +364,7 @@
 				sup = s;
 				break;
 			}
-			n = CQPEngine.getCqiClient().cpos2Struc(sup.getQualifiedName(), cpos);
+			n = CQPSearchEngine.getCqiClient().cpos2Struc(sup.getQualifiedName(), cpos);
 			return goToPage(n[0]);
 		} catch (Exception e) {
 			System.out.println("Error while internal view go back to " + line);
Index: tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java
===================================================================
--- tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java	(revision 785)
+++ tmp/org.txm.querycooccurrences.rcp/src/org/txm/rcp/commands/function/ComputeQueryAutoCooccurrence.java	(revision 786)
@@ -62,7 +62,7 @@
 import org.txm.rcp.utils.JobHandler;
 import org.txm.rcp.views.QueriesView;
 import org.txm.rcp.views.corpora.CorporaView;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.StructuralUnit;
@@ -136,7 +136,7 @@
 					return Status.CANCEL_STATUS;
 				} catch (Exception e) {
 					Log.printStackTrace(e);
-					try { System.out.println(TXMUIMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+					try { System.out.println(TXMUIMessages.LastCQPError+CQPSearchEngine.getCqiClient().getLastCQPError());
 					} catch (Exception e1) { e1.printStackTrace(); }
 				} finally {
 					monitor.done();
@@ -187,7 +187,7 @@
 
 		} catch (Exception e) {
 			Log.printStackTrace(e);
-			try { System.out.println(TXMUIMessages.LastCQPError+CQPEngine.getCqiClient().getLastCQPError());
+			try { System.out.println(TXMUIMessages.LastCQPError+CQPSearchEngine.getCqiClient().getLastCQPError());
 			} catch (Exception e1) { e1.printStackTrace(); }
 		}
 		return cooc;
Index: tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Train.java
===================================================================
--- tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Train.java	(revision 785)
+++ tmp/org.txm.treetagger.rcp/src/org/txm/treetagger/rcp/handlers/Train.java	(revision 786)
@@ -34,7 +34,7 @@
 import org.txm.rcp.swt.widget.parameters.ParametersDialog;
 import org.txm.rcp.utils.JobHandler;
 import org.txm.searchengine.cqp.AbstractCqiClient;
-import org.txm.searchengine.cqp.CQPEngine;
+import org.txm.searchengine.cqp.CQPSearchEngine;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.corpus.Property;
@@ -219,7 +219,7 @@
 					PrintStream ps = new PrintStream(fos);
 					LinkedHashSet<Integer> positions = new LinkedHashSet<Integer>();
 					Property word = corpus.getProperty("word");
-					AbstractCqiClient CQI = CQPEngine.getCqiClient();
+					AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
 					for (Match m : corpus.getMatches()) {
 						for (int i = m.getStart() ; i <= m.getEnd() ; i++) { // end match must be included
 							positions.add(i);
